<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>
<%@page import="java.util.ArrayList"%>
<%@page import="org.wso2.carbon.rest.api.stub.types.carbon.ResourceData"%>
<%@page import="java.util.List"%>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.rest.api.ui.client.RestApiAdminClient" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" src="js/api-util.js"></script>

<fmt:bundle basename="org.wso2.carbon.rest.api.ui.i18n.Resources">

<%
	ResourceBundle bundle = ResourceBundle.getBundle(
				"org.wso2.carbon.rest.api.ui.i18n.Resources",
				request.getLocale());
		String url = CarbonUIUtil.getServerURL(this.getServletConfig()
				.getServletContext(), session);
		ConfigurationContext configContext = (ConfigurationContext) config
				.getServletContext().getAttribute(
						CarbonConstants.CONFIGURATION_CONTEXT);
		String cookie = (String) session
				.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
		RestApiAdminClient client = new RestApiAdminClient(
				configContext, url, cookie, bundle.getLocale());

		String[] sequences = client.getDefinedSequences();

		String index = request.getParameter("index");
		ResourceData selectedResource = null;

		List<ResourceData> resources = (ArrayList<ResourceData>) session
				.getAttribute("apiResources");

		boolean hasGet = false;
		boolean hasPost = false;
		boolean hasPut = false;
		boolean hasDelete = false;
		boolean hasUrlStyle = false;
		boolean hasUriTemplate = false;

		if (resources != null) {
			selectedResource = resources.get(Integer.parseInt(index));

			String[] methods = selectedResource.getMethods();
			for (int i = 0; i < methods.length; i++) {
				String method = methods[i];
				if ("GET".equals(method)) {
					hasGet = true;
				} else if ("PUT".equals(method)) {
					hasPut = true;
				} else if ("POST".equals(method)) {
					hasPost = true;
				} else if ("DELETE".equals(method)) {
					hasDelete = true;
				}
			}
			if (selectedResource.getUriTemplate() != null
					&& !"".equals(selectedResource.getUriTemplate())) {
				hasUrlStyle = true;
				hasUriTemplate = true;
			} else if (selectedResource.getUrlMapping() != null
					&& !"".equals(selectedResource.getUrlMapping())) {
				hasUrlStyle = true;
				hasUriTemplate = false;
			}
		}
%>

<table class="normal-nopadding" width="100%">
     <!-- Methods-->
     <tr>
		<td class="leftCol-small">
			<fmt:message key="resource.methods.label"/>
		</td>
		<td style="display:inline; vertical-align:middle;">
			<div id="divGet" style="display:inline;">
				<fmt:message key="methods.get.label"/>
			</div>
			<input type="checkbox" name="methods" value="GET" 
				style="display:inline; vertical-align: middle" <%if (hasGet) {%>
																checked="checked"
															   <%}%>/>
			
			<div id="divPost" style="display:inline;">
				<fmt:message key="methods.post.label"/>
			</div>
			<input type="checkbox" name="methods" value="POST" 
				style="display:inline; vertical-align: middle" <%if (hasPost) {%>
																checked="checked"
															   <%}%>/>
			
			<div id="divPut" style="display:inline;">
				<fmt:message key="methods.put.label"/>
			</div>
			<input type="checkbox" name="methods" value="PUT" 
				style="display:inline; vertical-align: middle" <%if (hasPut) {%>
																checked="checked"
															   <%}%>/>
			
			<div id="divDelete" style="display:inline;">
				<fmt:message key="methods.delete.label"/>
			</div>
			<input type="checkbox" name="methods" value="DELETE" 
				style="display:inline; vertical-align: middle" <%if (hasDelete) {%>
																checked="checked"
															   <%}%>/>
		</td>
	</tr>
	<!-- URL Style-->
	<tr>
		<td class="leftCol-small">
			<fmt:message key="resource.urlstyle.label"/>
		</td>
		<td>
			<select id="urlStyle" onchange="urlStyleChanged()" >
				<option value="none" <%if (!hasUrlStyle) {%>selected="selected"<%}%>>
					<fmt:message key="resource.urlstyle.none"/>
				</option>
				<option value="uritemplate" <%if (hasUrlStyle && hasUriTemplate) {%>selected="selected"<%}%>>
					<fmt:message key="resource.urlstyle.template"/>
				</option>
				<option value="urlmapping" <%if (hasUrlStyle && !hasUriTemplate) {%>selected="selected"<%}%>>
					<fmt:message key="resource.urlstyle.mapping"/>
				</option>
			</select>
		</td>
	</tr>
	<!-- URI-Template / URL-Mapping -->
	<tr id="urlRow" <%if (!hasUrlStyle) {%>style="display:none;"<%}%>>
		<td id="uriTL" <%if (!hasUriTemplate) {%>style="display:none;"<%}%> class="leftCol-small">
			<fmt:message key="resource.uritempl.label"/>
		</td>
		<td id="urlML" <%if (hasUriTemplate) {%>style="display:none;"<%}%> class="leftCol-small">
			<fmt:message key="resource.urlmap.label"/>
		</td>
		<td>
			<input type="text" id="urlValue" <%if (hasUriTemplate) {%>
												value="<%=selectedResource.getUriTemplate()%>"
											<%} else {%>value="<%=selectedResource.getUrlMapping()%>"
											<%}%>/>
		</td>	
	</tr>
	<!-- In Sequence -->
	<tr>
		<td class="leftCol-small">
			<fmt:message key="resource.inseq.label"/>
		</td>
		<td>
			<select id="inSeq" >
				<option value="none">
					<fmt:message key="resource.sequence.none"/>
				</option>
				<%
				if (sequences != null && sequences.length != 0) {
					for (int i = 0; i < sequences.length; i++) {
				    %><option value="<%=sequences[i]%>"
				    	<%if(sequences[i].equals(selectedResource.getInSequenceKey())){%>
				    		selected="selected"
				    	<%}%>>
					    <%=sequences[i]%>
				      </option>
				    <%
					}
				}
				%>
			</select>
		</td>
	</tr>
	<!-- Out Sequence -->
	<tr>
		<td class="leftCol-small">
			<fmt:message key="resource.outseq.label"/>
		</td>
		<td>
			<select id="outSeq" >
				<option value="none">
					<fmt:message key="resource.sequence.none"/>
				</option>
				<%
				if (sequences != null && sequences.length != 0) {
					for (int i = 0; i < sequences.length; i++) {
				    %><option value="<%=sequences[i]%>"
				    	<%if(sequences[i].equals(selectedResource.getOutSequenceKey())){%>
				    		selected="selected"
				    	<%}%>>
					    <%=sequences[i]%>
				      </option>
				    <%
					}
				}
				%>
			</select>
		</td>
	</tr>
	<!-- Fault Sequence -->
	<tr>
		<td class="leftCol-small">
			<fmt:message key="resource.faultseq.label"/>
		</td>
		<td>
			<select id="faultSeq" >
				<option value="none">
					<fmt:message key="resource.sequence.none"/>
				</option>
				<%
				if (sequences != null && sequences.length != 0) {
					for (int i = 0; i < sequences.length; i++) {
				    %><option value="<%=sequences[i]%>"
				    	<%if(sequences[i].equals(selectedResource.getFaultSequenceKey())){%>
				    		selected="selected"
				    	<%}%>>
					    <%=sequences[i]%>
				      </option>
				    <%
					}
				}
				%>
			</select>
		</td>
	</tr>
</table>
<input type="button" value="<fmt:message key="update"/>"
             class="button"	name="updateBtn" onclick="updateResource()"/>
</fmt:bundle>
